/*
	
	PasswordView.h
	
	Copyright 1998, Neil Miller. All Rights Reserved.

	This source is free; you can redistribute it and/or modify it under 
	the terms of the a modified GNU Library General Public License OR 
	Mozilla Public License.
	See "http://www.pobox.com/~ngm/be/index.html" for full details.
	
*/


#ifndef	PASSWORD_VIEW_H
#define	PASSWORD_VIEW_H

#include <TextView.h>

#define C_UTF8_BULLET	"\xE2\x80\xA2"

class PasswordView : public BTextView {
public:
						PasswordView(BRect			frame,
								  const char	*name,
								  BRect			textRect,
								  uint32		resizeMask,
								  uint32		flags);
						PasswordView(BRect				frame, 
								  const char		*name, 
								  BRect				textRect,
						 	 	  const BFont		*initialFont,
								  const rgb_color	*initialColor, 
								  uint32			resizeMask, 
								  uint32			flags);
						PasswordView(BMessage *data);
	virtual				~PasswordView();
	
			const char*	Password() const;

	virtual	void		SetBlotChar( const char *blotChar );
			const char*	GetBlotChar() const;
		
			void		RequireASCII();

	virtual	void		KeyDown(const char *bytes, int32 numBytes);

protected:

	virtual	void		InsertText(const char				*inText, 
								   int32					inLength, 
								   int32					inOffset,
								   const text_run_array		*inRuns);
	virtual	void		DeleteText(int32 fromOffset, int32 toOffset);

private:

	int32	flags;
	int32	blotBytes;
	char	*blot; // can be UTF, should however be a single character
	char	*password;	
	char	*dragging;	
};

#endif
